#COMPILE EXE
#DIM ALL

#INCLUDE "WIN32API.inc"

GLOBAL CounterTSC1, CounterTSC2, CounterOverhead , CounterCycles AS QUAD
GLOBAL LoopCounter AS LONG   ' Use a 32-bit loop counter

SUB CounterCode1 

#REGISTER NONE 

    ! XOR eax, eax
    ! db &H0F,&HA2
    ! db &H0F,&H31
    ! mov CounterTSC1, eax
    ! mov CounterTSC1[4], edx

END SUB

SUB CounterCode2

#REGISTER NONE 

    ! XOR eax, eax
    ! db &H0F,&HA2
    ! db &H0F,&H31
    ! mov CounterTSC2, eax
    ! mov CounterTSC2[4], edx

END SUB

MACRO COUNTER_BEGIN( nLoops, priority_class )

    CounterOverhead = 2000000000
    CounterCycles   = 2000000000

    CALL SetPriorityClass( GetCurrentProcess, priority_class )

    SLEEP 0

    !  nop
    !  nop
    !  nop

    FOR LoopCounter = 1 TO nLoops
        CounterCode1
        CounterCode2
        IF (CounterTSC2 - CounterTSC1) < CounterOverhead THEN CounterOverhead = CounterTSC2 - CounterTSC1
    NEXT

    SLEEP 0

    !  nop
    !  nop
    !  nop

    FOR LoopCounter = 1 TO nLoops
        CounterCode1

END MACRO

MACRO COUNTER_END

        CounterCode2
        IF (CounterTSC2 - CounterTSC1) < CounterCycles THEN CounterCycles = CounterTSC2 - CounterTSC1
    NEXT

    CALL SetPriorityClass( GetCurrentProcess, %NORMAL_PRIORITY_CLASS )
    CounterCycles = CounterCycles - CounterOverhead

END MACRO

FUNCTION PBMAIN 

#REGISTER NONE 

    LOCAL s AS STRING

    COUNTER_BEGIN(1000, %HIGH_PRIORITY_CLASS)
        ! XOR edx, edx
        ! mov eax, 1
        ! div ecx
    COUNTER_END
    s = STR$(CounterCycles) + $CRLF

    COUNTER_BEGIN(1000, %HIGH_PRIORITY_CLASS)
        ! rcr eax, 31
        ! rcl eax, 31
    COUNTER_END
    s = s + STR$(CounterCycles) + $CRLF

    COUNTER_BEGIN(1000, %HIGH_PRIORITY_CLASS)
        ! pushad
        ! popad
    COUNTER_END
    s = s + STR$(CounterCycles) + $CRLF

    MSGBOX s

    EXIT FUNCTION

END FUNCTION